package org.netserv.ipauth.impl;

import java.io.IOException;

/**
 * The abstract class <code>LeaseReader</code> provides the interface of DHCP 
 * Lease Readers
 * 
 * @author Chiache Tsai
 */
public abstract class LeaseReader {
  /**
   * 
   * @param ip the IP addresses of the clients.
   * @return Client ID in bytes
   */
  public abstract byte[] getXid(byte[] ip);

  /**
   * Flush and load the Lease Database
   * @throws IOException
   */
  public abstract void load() throws IOException;
}
