/* dhcpc.h */
#ifndef _IPAUTH_H
#define _IPAUTH_H

#include <stdint.h>
#include "crypto.h"

struct ipauth_encrypted {
    uint32_t xid;
    uint32_t yaddr;
    uint8_t extlen;
    uint8_t ext[];
};

#define IPAUTH_PROVIDE_KEY      1
#define IPAUTH_CERT_REQUEST     2
#define IPAUTH_CERT_DEPLOY      3

struct ipauth_provide_key {
    uint8_t method;
    uint8_t keylen;
    uint8_t key[];
};

struct ipauth_cert_request {
    uint32_t reqlen;
    uint64_t reqhash;
};

struct ipauth_cert_deploy {
    uint32_t cerlen;
    uint64_t cerhash;
};

struct ipauth_suboption {
	uint8_t code;
	uint8_t optlen;
	uint8_t opt[];
};

struct ipauth_option {
    struct ipauth_encrypted *enc;
    struct ipauth_suboption *sub;
    uint8_t subnum;
};

int read_ipauth_option(uint32_t *xid, uint32_t *ip, struct key_suite *key, 
                       unsigned char *subcode, void **obj, unsigned char *from, int len);

int make_ipauth_option(uint32_t xid, uint32_t ip, struct key_suite *key,
                       unsigned char subcode, void *obj, unsigned char *to, int len);
X509 *ask_for_cert(uint32_t ip, struct key_suite *key);

int check_cert_deploy(struct ipauth_cert_deploy *sub, X509 *cert); 

#endif /* _IPAUTH_H_ */
